#include "global.h"
#include "MotorMath.h"

/*************************************************************
** Function name:       MovingAverageFilter_Speed
** Descriptions:        ƽ˲
** Input parameters:    xi ÿˢֵ
** Output parameters:   yk 
** Returned value:      None
** Remarks:             ٶ
*************************************************************/
float MovingAverageFilter_Speed(float xi)
{
  static short int MAF_index = -1;
  static float buffer[MAF_LENGTH_Speed];
  static float yk_1 = 0;
  float yk = 0;
  uint8_t i = 0;
  if (MAF_index == -1)
  { // ʼδʱǰݲ˲
    for (i = 0; i < MAF_LENGTH_Speed; i++)
    {
      buffer[i] = xi;
    }
    yk_1 = xi;
    MAF_index = 0;
    yk = yk_1;
  }
  else
  {//˲
    yk = yk_1 + (xi - buffer[MAF_index]) / MAF_LENGTH_Speed;
    buffer[MAF_index] = xi;
    MAF_index++;
    if (MAF_index >= MAF_LENGTH_Speed)
    {
      MAF_index = 0;
    }
	yk_1 = yk;
  }
  return yk;
}

/*************************************************************
** Function name:       MotorCurrentPIDControl
** Descriptions:        ٶPID
** Input parameters:    None
** Output parameters:   None
** Returned value:      None
** Remarks:             None
*************************************************************/
#if 1
void MotorSpeedPIDControl(struct indata_struct *pindata , struct setpara_s *psetpara)
{
  //ȡʵֵ
  //pindata->MotorSpeedPID.pre = pindata->real_speed; 
  pindata->MotorSpeedPID.pre = pindata->fused_speed;
  //ȡĿֵ
  pindata->MotorSpeedPID.tar = -(float)pindata->SpeedPIDInput / 100;    //ȡԭ򣺲ٳװ
  //ƫ
  pindata->MotorSpeedPID.bias = pindata->MotorSpeedPID.tar - pindata->MotorSpeedPID.pre;
  //PIDֵ  0.1fǱϵ
  pindata->MotorSpeedPID.out  = ((float)psetpara->SpeedPID_Kd * 0.1f) * (pindata->MotorSpeedPID.bias - pindata->MotorSpeedPID.lastBias) \  
                              + ((float)psetpara->SpeedPID_Kp * 0.1F) *  pindata->MotorSpeedPID.bias;                                      
  //ƫ
  pindata->MotorSpeedPID.lastBias = pindata->MotorCurrentPID.bias;

  //޷
  if (pindata->MotorSpeedPID.out > (float)psetpara->SpeedOutMax100X / 100) 
  {
    pindata->MotorSpeedPID.out = (float)psetpara->SpeedOutMax100X / 100;
  }
  if (pindata->MotorSpeedPID.out < (float)-psetpara->SpeedOutMax100X / 100) 
  {
    pindata->MotorSpeedPID.out = (float)-psetpara->SpeedOutMax100X / 100;
  }
// pindata->MotorSpeedPID.out = MovingAverageFilter_Speed(pindata->MotorSpeedPID.out);

}
#endif


/*************************************************************
** Function name:       MotorCurrentPIDControl
** Descriptions:        PID
** Input parameters:    None
** Output parameters:   None
** Returned value:      None
** Remarks:             None
*************************************************************/
#if 1
void MotorCurrentPIDControl(struct outdata_s *poutdata , struct indata_struct *pindata , struct setpara_s *psetpara)
{
  //ȡʵֵ
  pindata->MotorCurrentPID.pre = (float)pindata->Motor_Current_Value ;
  //ȡĿֵ
  //pindata->MotorCurrentPID.tar = (float)psetpara->SetMotorCurrent10X / 100;
  pindata->MotorCurrentPID.tar = (float)pindata->MotorSpeedPID.out;
  //ƫ
  pindata->MotorCurrentPID.bias = pindata->MotorCurrentPID.tar - pindata->MotorCurrentPID.pre;
  //PIDֵ  1fǱϵ
  pindata->MotorCurrentPID.out += ((float)psetpara->CurrentPID_Kp * 1.0f) * (pindata->MotorCurrentPID.bias - pindata->MotorCurrentPID.lastBias) \
                                + ((float)psetpara->CurrentPID_Ki * 1.0F) *  pindata->MotorCurrentPID.bias;
  //ƫ
  pindata->MotorCurrentPID.lastBias = pindata->MotorCurrentPID.bias;

  //޷
  if (pindata->MotorCurrentPID.out > (float)psetpara->CurrentOutMax) 
  {
    pindata->MotorCurrentPID.out = (float)psetpara->CurrentOutMax;
  }
  if (pindata->MotorCurrentPID.out < (float)-psetpara->CurrentOutMax) 
  {
    pindata->MotorCurrentPID.out = (float)-psetpara->CurrentOutMax;
  }

  //̬㲻ɾˣSTC32ķˣ16
  
  poutdata->MotorSpeedPWM = pindata->MotorCurrentPID.out;    //DEBUG for Current PID Circ

}
#endif



/*************************************************************
** Function name:       MotorCurrentRegulating
** Descriptions:        
** Input parameters:    None
** Output parameters:   None
** Returned value:      None
** Remarks:             ٶȻ⻷ڻ
*************************************************************/
void MotorCurrentRegulating(void)
{
  MotorADCStartOnce();                                      //ADCһΣȡʼADֵ
  MotorADCValueStorage();                                   //ƫò洢ADֵ
  MotorPreCurrentFilter(&indata);                           //ƽ˲
  MotorCurrentReconstruction(&indata);                      //عΪʵ
  MotorSpeedPIDControl(&indata , &setpara);                 //ٶȻPID
  MotorCurrentPIDControl(&outdata , &indata , &setpara);    //PID

}

