#include "global.h"
#include "data_input.h"

#define ENCODER_PULSE_PER_METER 112860

struct indata_struct indata = { 0 };
struct mycar_s mycar = { 0 } ;

filter_handle_s acc_x_filter;
int prev_acc_x_filter_cutoff = 0;


/*************************************************************
** Function name:       GetEncoderSpeedData
** Descriptions:        ȡ
** Input parameters:    indata pointer
** Output parameters:   None
** Returned value:      None
** Remarks:             None
*************************************************************/
void GetEncoderSpeedData(struct indata_struct *pindata)
{ 

 	if(!P51)
  {
		pindata->raw_speed = 2 * ctimer_count_read(CTIM0_P34); // 
	}
  else
  {
		pindata->raw_speed = 2 * (ctimer_count_read(CTIM0_P34)*-1); //
	}

	ctimer_count_clean(CTIM0_P34);
}

/*************************************************************
** Function name:       GetGyroscopeData
** Descriptions:        Ƕȡ
** Input parameters:    indata pointer
** Output parameters:   None
** Returned value:      None
** Remarks:             None
*************************************************************/
void GetGyroscopeData(struct indata_struct *pindata)
{ 
  unsigned char i;	
  float acc_x_origin;
  //ȡٶ
  get_icm20602_accdata_simiic();
  //ȡǼٶ
	get_icm20602_gyro_simiic();
  //xٶȻ
	acc_x_origin = -(icm_acc_x+340) * (float) (8. * 9.80665 / 32768.); //ٶȷǷ÷ʽȷüӸ

}

/*************************************************************
** Function name:       PeriphDataReconstruction
** Descriptions:        ⲿģݴ
** Input parameters:    indata pointer, flag pointer, setparameter pointer
** Output parameters:   None
** Returned value:      None
** Remarks:             None
*************************************************************/
void PeriphDataReconstruction(struct indata_struct *pindata ,struct flag_STRUCT *pflag ,struct setpara_s *psetpara)
{
  //ƽ˲
  pindata->raw_speed = MovingAverageFilter_Speed(pindata->raw_speed);
  //ʵٶȻ(δ궨)
	pindata->real_speed = (float) pindata->raw_speed * (1.f / ENCODER_PULSE_PER_METER) / (PIT_ms * 0.001f); 


  }
}


/*************************************************************
** Function name:       GetPeriphData
** Descriptions:        ȡֵ
** Input parameters:    None
** Output parameters:   None
** Returned value:      None
** Remarks:             ȡ
*************************************************************/
void GetPeriphData()
{
  GetGyroscopeData(&indata);                              //ȡٶ
  GetEncoderSpeedData(&indata);                           //ȡٶ
  PeriphDataReconstruction(&indata ,&flag ,&setpara);     //Ƕȡٶع
	get_ad_newvalue();                                      //ȡǰհ8ֵ

}


#define AVE_TIMES 15
int mid_i = (AVE_TIMES-3); // Third max
unsigned short int raw_ad[8][AVE_TIMES];  
// bubble sort function
void bubbleSort(unsigned short int array[], int n) {
  int i, j, temp;
  for (i = 0; i < n-1; i++) {
    for (j = 0; j < n-i-1; j++) {
      if (array[j] > array[j+1]) {
        //swap(&array[j], &array[j+1]);
        temp = array[j];
        array[j] = array[j+1];
        array[j+1] = temp;
      }
    }
  }
}

/******
LH LV LF MH MV RF RV RH
******/

void get_ad_value(void) 
{
  int i;
  for (i = 0; i < AVE_TIMES; i++) 
  {  
    raw_ad[1][i] = adc_once(ADC_P10, ADC_10BIT);   //LV
    raw_ad[4][i] = adc_once(ADC_P05, ADC_10BIT);   //MH
    raw_ad[6][i] = adc_once(ADC_P04, ADC_10BIT);   //LF
    raw_ad[0][i] = adc_once(ADC_P06, ADC_10BIT);   //LH
    raw_ad[2][i] = adc_once(ADC_P01, ADC_10BIT);   //RV
    raw_ad[5][i] = adc_once(ADC_P02, ADC_10BIT);   //RF
    raw_ad[7][i] = adc_once(ADC_P03, ADC_10BIT);   //MV
    raw_ad[3][i] = adc_once(ADC_P00, ADC_10BIT);   //RH
  }

  for (i = 0; i < 8; i++) 
  {
    bubbleSort(raw_ad[i], AVE_TIMES);
  }

  indata.real_ad[1] = (raw_ad[1][mid_i-1] + raw_ad[1][mid_i] + raw_ad[1][mid_i+1]) / 3; //LV
  indata.real_ad[4] = (raw_ad[4][mid_i-1] + raw_ad[4][mid_i] + raw_ad[4][mid_i+1]) / 3; //MH
  indata.real_ad[6] = (raw_ad[6][mid_i-1] + raw_ad[6][mid_i] + raw_ad[6][mid_i+1]) / 3; //LF
  indata.real_ad[0] = (raw_ad[0][mid_i-1] + raw_ad[0][mid_i] + raw_ad[0][mid_i+1]) / 3; //LH
  indata.real_ad[2] = (raw_ad[2][mid_i-1] + raw_ad[2][mid_i] + raw_ad[2][mid_i+1]) / 3; //RV
  indata.real_ad[5] = (raw_ad[5][mid_i-1] + raw_ad[5][mid_i] + raw_ad[5][mid_i+1]) / 3; //RF
  indata.real_ad[7] = (raw_ad[7][mid_i-1] + raw_ad[7][mid_i] + raw_ad[7][mid_i+1]) / 3; //MV
  indata.real_ad[3] = (raw_ad[3][mid_i-1] + raw_ad[3][mid_i] + raw_ad[3][mid_i+1]) / 3; //RH

  for(i=0;i<8;i++)
  {
    indata.ad[i]= 1.0*indata.real_ad[i]*setpara.ad_adjust/1000;
	}
}
#undef AVE_TIMES

//ADCֵ޷˲
void get_ad_newvalue(void) 
{
	int i,j;
  for(i = 0; i < 8; i++) 
  {
    indata.ad_old[i] = indata.ad[i];
  }
  get_ad_value();
  for( j = 0; j < 8; j++) 
  {
    if(indata.ad[j] - indata.ad_old[j] >= 40) 
    {
      indata.ad[j] =(indata.ad_old[j] + 40);
    } 
    else if((indata.ad_old[j] - indata.ad[j]) > 40) 
    {
      indata.ad[j] = (indata.ad_old[j] - 40);
    }
  }
}




void KeyScan()
{
  static unsigned int PressCount = 0;

  if(!P37)  //ⰴ£Ч
  {
    if(PressCount < 50)
    {
      PressCount++;
    }
    else if(PressCount == 50)                       //ⳤ¼
    {
      PressCount++;                                  //ʹ䲻жֹظжΪ
      TSUI_SetButtonEvent(LongPress);
    }
  }
  else     //δ⵽򰴼ɿ
  {
    if(PressCount > 2)
    {
      TSUI_SetButtonEvent(PRESS);    //̰¼
    }
    PressCount = 0;
  }
}


